<?php
header("Content-type:text/html; charset='utf-8'");

/*
Plugin Name: cleanUpload
Description: Удаляет неиспользуемые в контенте файлы из upload
Version: 1.1
Author: BATPYIIIKOB
Author URI: http://get-simple.info/forums/showthread.php?tid=7262
*/

spl_autoload_register(function ($class) {
    include 'cleanUpload/' . $class . '.php';
});

# получение корректного идентификатора плагина
$thisfile = basename(__FILE__, ".php");

# add in this plugin's language file
i18n_merge($thisfile) || i18n_merge($thisfile, 'en_US');

# регистрируем плагин в системе
register_plugin(
    $thisfile, //идентификатор плагина
    i18n_r($thisfile.'/CLEAN_TITLE'), //Название плагина
    '1.1', 		//Версия плагина
    'BATPYIIIKOB',  //автор плагина
    'http://get-simple.info/forums/showthread.php?tid=7262', //сайт автора
    'Удаляет неиспользуемые в контенте файлы из upload', //краткое описание плагина
    'files', //тип страницы – на какой из вкладок административной панели появится плагин
    'clean_upload'  //главная функция плагина (функция администрирования)
);

# activate filter/активируем фильтр
add_action('files-content','clean_upload');

# Добавляем ссылку на вкладку Темы
add_action('files-sidebar','createSideMenu',array($thisfile,i18n_r("cleanUpload/CLEAN_TITLE")));

# Преобразование размеров файла в удобочитаемый вид
function human_filesize($bytes, $decimals = 2) {
  $sz = 'BKMGTP';
  $factor = floor((strlen($bytes) - 1) / 3);
  return sprintf("%.{$decimals}f", $bytes / pow(1024, $factor)) . @$sz[$factor];
}

# Вывод результата на экран
function PrePrintArray($arr){
	$sum_size = 0;

    echo '<br><b>'.i18n_r("cleanUpload/FILES_NOT_USE").count($arr).'</b><br><br>';

	echo '<table>';

    foreach ($arr as &$filename) {

		echo "<tr><td><i>$filename</i></td>";
		echo "<td>".human_filesize(filesize("../".$filename));		
		echo "</td></tr>";
		$sum_size = filesize("../".$filename)+$sum_size;
	}

    echo '<tr style="background-color:#86C6EC;color:#336699;"><td><b>';
    echo i18n("cleanUpload/COMMON_DEL_FILES");
    echo '</b></td><td><b>' . human_filesize($sum_size) . '</b></td></tr></table>';
}



# Удалить найденные файлы
function deleteResult($arr){
    $sum_size = 0;
    //echo '<br><b>'."Удалённых файлов: ".count($arr).'</b><br><br>';
    echo '<table>';

    foreach ($arr as &$filename) {
        unlink("../".$filename);
        echo "<tr><td><i>$filename</i></td>";
        echo "<td><i>".i18n_r("cleanUpload/DELETED")."</i></td>";
        echo "</tr>";
    }

    echo '<tr style="background-color:#86C6EC;color:#336699;"><td><b>';
    echo i18n("cleanUpload/COMMON_DEL_FILES");
    echo '</b></td></tr></table>';
}


# Теперь – функции плагина
function clean_upload() {
    $DATA_GALLERY_PATH = '../data/i18n_gallery/';
    $DATA_UPLOAD_PATH = '../data/uploads';
    $DATA_PAGES_PATH = '../data/pages/';

    i18n("cleanUpload/DESCRIPTION");

    echo "<br><br><form method='POST'>";
    echo "<input type='submit' class='submit' name='find-files' value=".i18n_r("cleanUpload/BTN_FIND").">";
    echo "<hr>";


    if (isset($_POST['find-files']) or isset($_POST['delete-result'])) {

        # Анализ страниц ../data/pages/
        $links = new PageAnalize();
        $links_arr = $links ->PageAnalizeContent($DATA_PAGES_PATH);

        # Анализ фотоальбомов ../data/i18n_gallery/
        $links_gallery = new GalleryAnalize();
        $links_gallery_arr  = $links_gallery -> PageAnalizeGallery($DATA_GALLERY_PATH);

        # Анализ директории с файлами ../data/uploads
        $upfiles = new UploadAnalize();
        $upfiles_arr = $upfiles -> ListFilesDirectory($DATA_UPLOAD_PATH);

        # из всех ссылок на файлы в Upload удаляем ссылки которые используются в контенте и галлереи
        $diff_arr = array_diff($upfiles_arr,$links_arr,$links_gallery_arr);

        # если нажали кнопку "Удалить всё"
        if (isset($_POST['delete-result'])){
            deleteResult($diff_arr);
        }else{
            if (!empty($diff_arr)) {
                PrePrintArray($diff_arr);
                echo "<br><hr>";
                i18n("cleanUpload/RECOMENDATION_CLEAN");
                echo "<br><br>";
                echo "<input type='submit' class='submit' name='delete-result' value=".i18n_r("cleanUpload/BTN_DEL").">";
            }else{
                i18n("cleanUpload/FILES_NOT_CLEAN");
            }
        }
    }

    echo "</form>";
}

?>